## python-autobahn 17.10.1+dfsg1

=== wstest/Makefile ===
CURDIR := $(CURDIR)

default:
	@echo 'targets: clean, downloads, build_wstest'


clean:
	-rm -rf ./reports
	#-rm -rf ./downloads
	-rm -rf ./venv*
	-rm -rf ./wstest

clean_reports:
	-rm -rf ./reports

upload_reports:
	./wstest/bin/aws s3 sync reports s3://autobahn.ws/testsuite/reports \
		--delete --acl public-read --region=eu-central-1


downloads:
	mkdir -p downloads
	wget -P downloads https://bootstrap.pypa.io/get-pip.py
	wget -P downloads https://bitbucket.org/pypy/pypy/downloads/pypy2-v5.7.0-linux64.tar.bz2
	wget -P downloads https://bitbucket.org/pypy/pypy/downloads/pypy3-v5.7.0-linux64.tar.bz2
	wget -P downloads https://www.python.org/ftp/python/2.7.13/Python-2.7.13.tar.xz
	wget -P downloads https://www.python.org/ftp/python/3.6.0/Python-3.6.0.tar.xz


build_wstest:
	mkdir -p ./wstest
	tar xvf ./downloads/pypy2-v5.7.0-linux64.tar.bz2 --strip-components=1 -C ./wstest
	./wstest/bin/pypy ./downloads/get-pip.py
	./wstest/bin/pip install autobahntestsuite
	./wstest/bin/pip install awscli


build_pypy2:
	mkdir -p ./pypy2
	tar xvf ./downloads/pypy2-v5.7.0-linux64.tar.bz2 --strip-components=1 -C ./pypy2
	#cd ./pypy2/bin && ln -s pypy python && cd ../..
	./pypy2/bin/python ./downloads/get-pip.py
	./pypy2/bin/pip install virtualenv
	./pypy2/bin/python -V

build_pypy3:
	mkdir -p ./pypy3
	tar xvf ./downloads/pypy3-v5.7.0-linux64.tar.bz2 --strip-components=1 -C ./pypy3
	#cd ./pypy3/bin && ln -s pypy3 python && cd ../..
	./pypy3/bin/python ./downloads/get-pip.py
	./pypy3/bin/pip install virtualenv
	./pypy3/bin/python -V

build_cpy2:
	mkdir -p ./cpy2_build
	tar xvf ./downloads/Python-2.7.13.tar.xz --strip-components=1 -C ./cpy2_build
	cd ./cpy2_build && ./configure --prefix=${CURDIR}/cpy2 && make && make install
	rm -rf ./cpy2_build
	./cpy2/bin/python ./downloads/get-pip.py
	./cpy2/bin/pip install virtualenv
	./cpy2/bin/python -V

build_cpy3:
	mkdir -p ./cpy3_build
	tar xvf ./downloads/Python-3.6.0.tar.xz --strip-components=1 -C ./cpy3_build
	cd ./cpy3_build && ./configure --prefix=${CURDIR}/cpy3 && make && make install
	cd ./cpy3/bin && ln -s python3 python && cd ../..
	cd ./cpy3/bin && ln -s pip3 pip && cd ../..
	rm -rf ./cpy3_build
	./cpy3/bin/pip install virtualenv
	./cpy3/bin/python -V

build: build_wstest \
	   build_pypy2 \
	   build_pypy3 \
	   build_cpy2 \
	   build_cpy3


versions:
	./cpy2/bin/python -V
	./cpy3/bin/python -V
	./pypy2/bin/python -V
	./pypy3/bin/python -V


setup_pypy2_tx:
	./pypy2/bin/virtualenv ./venv_pypy2_tx
	./venv_pypy2_tx/bin/pip install -e ..[twisted]

setup_pypy2_aio:
	./pypy2/bin/virtualenv ./venv_pypy2_aio
	./venv_pypy2_aio/bin/pip install -e ..[asyncio]

setup_pypy3_tx:
	./pypy3/bin/virtualenv ./venv_pypy3_tx
	./venv_pypy3_tx/bin/pip install -e ..[twisted]

setup_pypy3_aio:
	./pypy3/bin/virtualenv ./venv_pypy3_aio
	./venv_pypy3_aio/bin/pip install -e ..[asyncio]

setup_cpy2_tx:
	./cpy2/bin/virtualenv ./venv_cpy2_tx
	./venv_cpy2_tx/bin/pip install -e ..[twisted]

setup_cpy2_aio:
	./cpy2/bin/virtualenv ./venv_cpy2_aio
	./venv_cpy2_aio/bin/pip install -e ..[asyncio]

setup_cpy3_tx:
	./cpy3/bin/virtualenv ./venv_cpy3_tx
	./venv_cpy3_tx/bin/pip install -e ..[twisted]

setup_cpy3_aio:
	./cpy3/bin/virtualenv ./venv_cpy3_aio
	./venv_cpy3_aio/bin/pip install -e ..[asyncio]

setup: setup_pypy2_tx \
	   setup_pypy2_aio \
	   setup_pypy3_tx \
	   setup_pypy3_aio \
	   setup_cpy2_tx \
	   setup_cpy2_aio \
	   setup_cpy3_tx \
	   setup_cpy3_aio


wstest_server:
	./wstest/bin/wstest -m fuzzingserver


test_pypy2_tx_client:
	./venv_pypy2_tx/bin/python testee_client_tx.py

test_pypy2_aio_client:
	./venv_pypy2_aio/bin/python testee_client_aio.py

test_pypy3_tx_client:
	./venv_pypy3_tx/bin/python testee_client_tx.py

test_pypy3_aio_client:
	./venv_pypy3_tx/bin/python testee_client_aio.py

test_cpy2_tx_client:
	./venv_cpy2_tx/bin/python testee_client_tx.py

test_cpy2_aio_client:
	./venv_cpy2_aio/bin/python testee_client_aio.py

test_cpy3_tx_client:
	./venv_cpy3_tx/bin/python testee_client_tx.py

test_cpy3_aio_client:
	./venv_cpy3_tx/bin/python testee_client_aio.py


test_tx_client: \
	test_pypy2_tx_client \
	test_pypy3_tx_client \
	test_cpy2_tx_client \
	test_cpy3_tx_client

test_aio_client: \
	test_pypy2_aio_client \
	test_pypy3_aio_client \
	test_cpy2_aio_client \
	test_cpy3_aio_client

test_client: \
	test_tx_client \
	test_aio_client


start_cpy2_tx_server:
	./venv_cpy2_tx/bin/python testee_server_tx.py --url ws://127.0.0.1:9010 &

start_cpy3_tx_server:
	./venv_cpy3_tx/bin/python testee_server_tx.py --url ws://127.0.0.1:9011 &

start_pypy2_tx_server:
	./venv_pypy2_tx/bin/python testee_server_tx.py --url ws://127.0.0.1:9012 &

start_pypy3_tx_server:
	./venv_pypy3_tx/bin/python testee_server_tx.py --url ws://127.0.0.1:9013 &


start_cpy2_aio_server:
	./venv_cpy2_aio/bin/python testee_server_aio.py --url ws://127.0.0.1:9014 &

start_cpy3_aio_server:
	./venv_cpy3_aio/bin/python testee_server_aio.py --url ws://127.0.0.1:9015 &

start_pypy2_aio_server:
	./venv_pypy2_aio/bin/python testee_server_aio.py --url ws://127.0.0.1:9016 &

start_pypy3_aio_server:
	./venv_pypy3_aio/bin/python testee_server_aio.py --url ws://127.0.0.1:9017 &


start_tx_server: \
	start_cpy2_tx_server \
	start_cpy3_tx_server \
	start_pypy2_tx_server \
	start_pypy3_tx_server

start_aio_server: \
	start_cpy2_aio_server \
	start_cpy3_aio_server \
	start_pypy2_aio_server \
	start_pypy3_aio_server

start_server: \
	start_tx_server \
	start_aio_server


stop_server:
	-pkill -f "testee_server*"


# test individual server flavor - note that this will only
# produce a single report each, and it cannot be combined into
# a single report! here is the comment from wstest.py

# allow overriding servers from command line option, providing 1 server
# this is semi-useful, as you cannot accumulate a combined report for
# multiple servers by running wstest over and over again. the generated
# report is only for the last invocation - it would require a massive
# code restructering / rewriting to change that. no time for that unfort.

test_cpy2_tx_server:
	./wstest/bin/wstest -m fuzzingclient -w ws://127.0.0.1:9010

test_cpy3_tx_server:
	./wstest/bin/wstest -m fuzzingclient -w ws://127.0.0.1:9011

test_pypy2_tx_server:
	./wstest/bin/wstest -m fuzzingclient -w ws://127.0.0.1:9012

test_pypy3_tx_server:
	./wstest/bin/wstest -m fuzzingclient -w ws://127.0.0.1:9013


test_cpy2_aio_server:
	./wstest/bin/wstest -m fuzzingclient -w ws://127.0.0.1:9014

test_cpy3_aio_server:
	./wstest/bin/wstest -m fuzzingclient -w ws://127.0.0.1:9015

test_pypy2_aio_server:
	./wstest/bin/wstest -m fuzzingclient -w ws://127.0.0.1:9016

test_pypy3_aio_server:
	./wstest/bin/wstest -m fuzzingclient -w ws://127.0.0.1:9017


test_tx_server: \
	test_cpy2_tx_server \
	test_cpy3_tx_server \
	test_pypy2_tx_server \
	test_pypy3_tx_server

test_aio_server: \
	test_cpy2_aio_server \
	test_cpy3_aio_server \
	test_pypy2_aio_server \
	test_pypy3_aio_server

# THIS DOES NOT WORK TO PRODUCE THE FINAL COMBINED REPORT FOR ALL SERVERS!
# see above.
#test_server: \
#	test_tx_server \
#	test_aio_server


test_server:
	./wstest/bin/wstest -m fuzzingclient

=== debian/changelog ===
python-autobahn (17.10.1+dfsg1-7) unstable; urgency=high

  * CVE-2020-35678: allows redirect header injection. Applied upstream patch:
    URL must be re-encoded when doing redirect (Closes: #978416).

 -- Thomas Goirand <zigo@debian.org>  Mon, 07 Jun 2021 09:49:43 +0200

python-autobahn (17.10.1+dfsg1-6) unstable; urgency=medium

  * Removed Python 2 support (Closes: #937590).

 -- Thomas Goirand <zigo@debian.org>  Tue, 10 Sep 2019 12:10:34 +0200

python-autobahn (17.10.1+dfsg1-5) unstable; urgency=medium

  [ Ondřej Nový ]
  * Running wrap-and-sort -bast.
  * Use debhelper-compat instead of debian/compat.

  [ Thomas Goirand ]
  * Re-upload source-only.

 -- Thomas Goirand <zigo@debian.org>  Mon, 05 Aug 2019 10:56:41 +0200

python-autobahn (17.10.1+dfsg1-4) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/control: Use team+openstack@tracker.debian.org as maintainer

  [ Thomas Goirand ]
  * Use pyqrcode, not just qrcode (Closes: #931612).

 -- Thomas Goirand <zigo@debian.org>  Mon, 08 Jul 2019 11:39:13 +0200

python-autobahn (17.10.1+dfsg1-3) unstable; urgency=medium

  * Fixed upstream VCS URL in debian/rules.
  * Add Python 3.7 patch (Closes: #903423).

 -- Thomas Goirand <zigo@debian.org>  Tue, 10 Jul 2018 09:02:46 +0200

python-autobahn (17.10.1+dfsg1-2) unstable; urgency=medium

  * Uploading to unstable.

 -- Thomas Goirand <zigo@debian.org>  Sun, 25 Feb 2018 20:38:09 +0000

python-autobahn (17.10.1+dfsg1-1) experimental; urgency=medium

  [ Ondřej Nový ]
  * d/control: Set Vcs-* to salsa.debian.org

  [ Thomas Goirand ]
  * New upstream release.
  * Removed python-msgpack from (build-)depends, upstream now uses u-msgpack.

 -- Thomas Goirand <zigo@debian.org>  Thu, 22 Feb 2018 13:17:17 +0000

python-autobahn (17.7.1+dfsg1-3) unstable; urgency=medium

  * Uploading to unstable.
  * Do not runtime depends on python3-trollius anymore (Closes: #868203).
  * Using debhelper 10.
  * Standards-Version is now 4.1.1.

 -- Thomas Goirand <zigo@debian.org>  Sun, 29 Oct 2017 17:33:10 +0100

python-autobahn (17.7.1+dfsg1-2) experimental; urgency=medium

  * Added missing openstack-pkg-tools build-dep (Closes: #876235).

 -- Thomas Goirand <zigo@debian.org>  Wed, 20 Sep 2017 21:03:16 +0000

python-autobahn (17.7.1+dfsg1-1) experimental; urgency=medium

  [ Daniel Baumann ]
  * Updating vcs fields.
  * Updating copyright format url.
  * Updating maintainer field.
  * Running wrap-and-sort -bast.
  * Updating standards version to 4.0.0.
  * Removing gbp.conf, not used anymore or should be specified in the
    developers dotfiles.
  * Updating standards version to 4.0.1.
  * Updating standards version to 4.1.0.

  [ Thomas Goirand ]
  * New upstream release.
  * Updated debian/copyright.
  * Fixed (build-)depends for this release.
  * Now using pkgos-dh_auto_install.
  * Removed Work-around_old_vs._new_twisted_client-endpoint_parser.patch
    applied upstream.
  * Fixed tests to run in the autobahn folder only.

 -- Thomas Goirand <zigo@debian.org>  Wed, 13 Sep 2017 21:21:45 +0200

=== debian/control ===
Source: python-autobahn
Section: python
Priority: optional
Maintainer: Debian OpenStack <team+openstack@tracker.debian.org>
Uploaders:
 Thomas Goirand <zigo@debian.org>,
Build-Depends:
 debhelper-compat (= 10),
 dh-python,
 openstack-pkg-tools (>= 99~),
 python3-sphinx,
 python3-sphinx-rtd-theme,
 python3-all,
 python3-setuptools,
Build-Depends-Indep:
 python3-cbor (>= 1.0.0),
 python3-enchant,
 python3-lz4,
 python3-mock,
 python3-nacl,
 python3-openssl,
 python3-pyqrcode,
 python3-pytest,
 python3-service-identity,
 python3-six,
 python3-snappy,
 python3-trie,
 python3-twisted,
 python3-txaio,
 python3-u-msgpack,
 python3-ubjson,
 python3-unittest2,
 python3-wsaccel,
 python3-zope.interface,
Standards-Version: 4.1.1
Vcs-Browser: https://salsa.debian.org/openstack-team/python/python-autobahn
Vcs-Git: https://salsa.debian.org/openstack-team/python/python-autobahn.git
Homepage: http://autobahn.ws/python

Package: python3-autobahn
Architecture: all
Depends:
 python3-cbor (>= 1.0.0),
 python3-lz4,
 python3-nacl,
 python3-openssl,
 python3-pyqrcode,
 python3-service-identity,
 python3-six,
 python3-snappy,
 python3-trie,
 python3-twisted,
 python3-txaio,
 python3-u-msgpack,
 python3-ubjson,
 python3-wsaccel,
 python3-zope.interface,
 ${misc:Depends},
 ${python3:Depends},
Description: WebSocket client and server library, WAMP framework - Python 3.x
 Autobahn|Python is a networking library that is part of the Autobahn project
 and provides implementations of:
  * The WebSocket Protocol
  * The Web Application Messaging Protocol (WAMP)
 for Twisted and asyncio, on Python 2 & 3 and for writing servers and clients.
 .
 WebSocket allows bidirectional real-time messaging on the Web and WAMP adds
 asynchronous Remote Procedure Calls and Publish & Subscribe on top of
 WebSocket.
 .
 This package contains the Python 3.x module.

## python-autobahn 21.11.1%2Bdfsg1

=== debian/changelog ===
python-autobahn (21.11.1+dfsg1-2build1) jammy; urgency=medium

  * No-change rebuild with Python 3.10 only

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 16 Mar 2022 21:44:48 +0000

python-autobahn (21.11.1+dfsg1-2) unstable; urgency=medium

  * Add missing debian/python3-autobahn.install.

 -- Thomas Goirand <zigo@debian.org>  Tue, 28 Dec 2021 19:44:31 +0100

python-autobahn (21.11.1+dfsg1-1) unstable; urgency=medium

  [ Ondřej Nový ]
  * Run wrap-and-sort -bastk.

  [ Thomas Goirand ]
  * New upstream release.
  * Fixed (build-)depends for this release.
  * Removed py 3.7 patch, not needed anymore.
  * pytest: Use -Wignore to ignore deprecation warnings.
  * Add export USE_ASYNCIO = 1 in debian/rules.
  * Correctly set the test folder when running tests.

 -- Thomas Goirand <zigo@debian.org>  Tue, 08 Sep 2020 10:15:16 +0200

=== debian/control ===
--- 
+++ 
@@ -8,28 +8,37 @@
  debhelper-compat (= 10),
  dh-python,
  openstack-pkg-tools (>= 99~),
+ python3-all,
+ python3-setuptools,
  python3-sphinx,
  python3-sphinx-rtd-theme,
- python3-all,
- python3-setuptools,
 Build-Depends-Indep:
- python3-cbor (>= 1.0.0),
+ python3-attr (>= 19.2.0),
+ python3-base58,
+ python3-cbor,
+ python3-cffi (>= 1.11.5),
+ python3-cryptography (>= 3.3.2),
+ python3-ecdsa,
+ python3-flatbuffers,
  python3-enchant,
+ python3-hyperlink,
  python3-lz4,
- python3-mock,
+ python3-mnemonic,
+ python3-msgpack (>= 1.0.2),
  python3-nacl,
  python3-openssl,
+ python3-passlib,
  python3-pyqrcode,
  python3-pytest,
- python3-service-identity,
- python3-six,
+ python3-pytest-asyncio,
+ python3-service-identity (>= 18.1.0),
  python3-snappy,
- python3-trie,
- python3-twisted,
- python3-txaio,
+ python3-trie (>= 0.4.0),
+ python3-twisted (>= 20.3.0),
+ python3-txaio (>= 21.2.1),
  python3-u-msgpack,
  python3-ubjson,
- python3-unittest2,
+ python3-ujson,
  python3-wsaccel,
  python3-zope.interface,
 Standards-Version: 4.1.1
@@ -40,19 +49,29 @@
 Package: python3-autobahn
 Architecture: all
 Depends:
- python3-cbor (>= 1.0.0),
+ python3-attr (>= 19.2.0),
+ python3-base58,
+ python3-cbor,
+ python3-cffi (>= 1.11.5),
+ python3-cryptography (>= 3.3.2),
+ python3-ecdsa,
+ python3-flatbuffers,
+ python3-hyperlink,
  python3-lz4,
+ python3-mnemonic,
+ python3-msgpack (>= 1.0.2),
  python3-nacl,
  python3-openssl,
+ python3-passlib,
  python3-pyqrcode,
- python3-service-identity,
- python3-six,
+ python3-service-identity (>= 18.1.0),
  python3-snappy,
- python3-trie,
+ python3-trie (>= 0.4.0),
  python3-twisted,
- python3-txaio,
+ python3-txaio (>= 21.2.1),
  python3-u-msgpack,
  python3-ubjson,
+ python3-ujson,
  python3-wsaccel,
  python3-zope.interface,
  ${misc:Depends},

## python-autobahn 21.11.1+dfsg1

=== Makefile ===
.PHONY: test docs pep8 build

WHEELS=https://crossbarbuilder.s3.eu-central-1.amazonaws.com/wheels
XBRNETWORK=${HOME}/.local/bin/xbrnetwork

all:
	@echo "Targets:"
	@echo ""
	@echo "   clean            Cleanup"
	@echo "   install          Local install"
	@echo "   publish          Clean build, register and publish to PyPi"
	@echo "   test             Run unit tests"
	@echo "   flake8           Run flake8 code checking"
	@echo ""

# deprecated with v21.2.1 (ABI files are no longer bundled in this package)
abi_files:
	curl -s https://xbr.network/lib/abi/xbr-protocol-latest.zip -o /tmp/xbr-protocol-latest.zip
	unzip -t /tmp/xbr-protocol-latest.zip
	rm -rf ${PWD}/autobahn/xbr/contracts
	unzip /tmp/xbr-protocol-latest.zip -d ${PWD}/autobahn/xbr/contracts

# install locally
install:
	-pip uninstall -y pytest_asyncio # remove the broken shit
	-pip uninstall -y pytest_cov # remove the broken shit
	# enforce use of bundled libsodium
	AUTOBAHN_USE_NVX=1 SODIUM_INSTALL=bundled pip install -e .[all]

build:
	-rm -f dist/*
	# AUTOBAHN_USE_NVX=0 python setup.py sdist --universal
	AUTOBAHN_USE_NVX=1 python setup.py sdist
	ls -la dist

# upload to our internal deployment system
upload: clean
	AUTOBAHN_USE_NVX=0 python setup.py sdist --universal
	aws s3 cp --acl public-read \
		dist/autobahn-*.whl \
		s3://fabric-deploy/autobahn/

# cleanup everything
clean:
	-rm -f ./*.so
	-rm -rf ./docs/build
	-rm -rf ./.cache
	-rm -rf ./autobahn.egg-info
	-rm -rf ./build
	-rm -rf ./dist
	-rm -rf ./temp
	-rm -rf ./_trial_temp
	-rm -rf ./.tox
	-rm -rf ./.eggs
	-rm -rf ./htmlcov
	-rm -f ./.coverage
	-rm -f ./coverage.xml
	-rm -f ./.coverage.*
	-rm -rf ~/coverage
	-rm -f  ./twisted/plugins/dropin.cache
	-find . -name "*dropin.cache.new" -type f -exec rm -f {} \;
	-find . -name ".pytest_cache" -type d -exec rm -rf {} \;
	-find . -name "*.tar.gz" -type f -exec rm -f {} \;
	-find . -name "*.egg" -type f -exec rm -f {} \;
	-find . -name "*.pyc" -type f -exec rm -f {} \;

	# Learn to love the shell! http://unix.stackexchange.com/a/115869/52500
	-find . \( -name "*__pycache__" -type d \) -prune -exec rm -rf {} +

# publish to PyPI
publish: clean
	AUTOBAHN_USE_NVX=0 python setup.py sdist --universal
	twine upload dist/*

clean_docs:
	-rm -rf ./docs/build

docs:
	tox -e sphinx

spelling:
	cd docs && sphinx-build -b spelling . _spelling

run_docs:
	twistd --nodaemon web --port=tcp:8090 --path=./docs/_build/


clean_wheels:
	rm -rf ./.wheels
	mkdir -p ./.wheels/

download_wheels:
	mkdir -p ./.wheels/
	rm -f ./.wheels/*.whl
	curl -o ./.wheels/txaio-latest-py2.py3-none-any.whl 	$(WHEELS)/txaio-latest-py2.py3-none-any.whl
	curl -o ./.wheels/zlmdb-latest-py2.py3-none-any.whl 	$(WHEELS)/zlmdb-latest-py2.py3-none-any.whl
	curl -o ./.wheels/xbr-latest-py2.py3-none-any.whl 		$(WHEELS)/xbr-latest-py2.py3-none-any.whl
	curl -o ./.wheels/autobahn-latest-py2.py3-none-any.whl 	$(WHEELS)/autobahn-latest-py2.py3-none-any.whl
	ls -la ./.wheels

build_this_wheel:
	mkdir -p ./.wheels/
	rm -f ./.wheels/autobahn*.whl
	pip3 wheel --no-deps --wheel-dir=./.wheels ..
	mv .wheels/autobahn*.whl .wheels/autobahn-latest-py2.py3-none-any.whl
	ls -la ./.wheels

download_exe:
	curl -o $(XBRNETWORK) \
		https://download.crossbario.com/xbrnetwork/linux-amd64/xbrnetwork-latest
	chmod +x $(XBRNETWORK)
	$(XBRNETWORK) version

build_exe:
	tox -e buildexe

upload_exe:
	aws s3 cp --acl public-read \
		./dist/xbrnetwork \
		s3://download.crossbario.com/xbrnetwork/linux-amd64/${XBRNETWORK_EXE_FILENAME}
	aws s3 cp --acl public-read \
		./dist/xbrnetwork \
		s3://download.crossbario.com/xbrnetwork/linux-amd64/xbrnetwork-latest
	# aws s3api copy-object --acl public-read --copy-source \
	# 	download.crossbario.com/xbrnetwork/linux-amd64/${XBRNETWORK_EXE_FILENAME} \
	# 	--bucket download.crossbario.com \
	# 	--key xbrnetwork/linux-amd64/xbrnetwork-latest
	aws cloudfront create-invalidation \
		--distribution-id E2QIG9LNGCJSP9 --paths "/xbrnetwork/linux-amd64/*"


test_xbr_cli:
	xbrnetwork
	xbrnetwork version
	xbrnetwork get-member
	xbrnetwork get-market --market=1388ddf6-fe36-4201-b1aa-cb7e36b4cfb3
	xbrnetwork get-actor
	xbrnetwork get-actor --market=1388ddf6-fe36-4201-b1aa-cb7e36b4cfb3

test_mnemonic:
	# python -m pytest -rsx autobahn/xbr/test/test_mnemonic.py
	USE_TWISTED=1 trial autobahn.xbr.test

test_nvx:
	python -m pytest -rsx autobahn/nvx/test
	USE_TWISTED=1 trial autobahn.nvx.test.test_utf8validator

test_styleguide:
	flake8 --statistics --max-line-length=119 -qq autobahn

# direct test via pytest (only here because of setuptools test integration)
test_pytest:
	USE_ASYNCIO=1 python -m pytest -c setup.cfg -rsvx autobahn/

# test via setuptools command
test_setuptools:
	python setup.py test

test:
	tox -e flake8,py37-twtrunk,py37-asyncio,coverage

#test: flake8 test_twisted test_asyncio

# test under Twisted
test_twisted:
	USE_TWISTED=1 trial autobahn
	#WAMP_ROUTER_URL="ws://127.0.0.1:8080/ws" USE_TWISTED=1 trial autobahn

test_application_runner:
	USE_TWISTED=1 trial autobahn.twisted.test.test_tx_application_runner

test_util:
	USE_TWISTED=1 trial autobahn.test.test_util

test_rng:
	USE_TWISTED=1 trial autobahn.test.test_rng

test_tx_serializer:
	USE_TWISTED=1 trial autobahn.wamp.test.test_serializer

test_tx_cryptobox:
	USE_TWISTED=1 trial autobahn.wamp.test.test_cryptobox

test_tx_choosereactor:
	USE_TWISTED=1 trial autobahn.twisted.test.test_choosereactor

test_tx_cryptosign:
	#USE_ASYNCIO=1 trial autobahn.wamp.test.test_wamp_cryptosign.TestAuth.test_testvectors
	#USE_TWISTED=1 trial autobahn.wamp.test.test_wamp_cryptosign.TestAuth.test_testvectors
	USE_ASYNCIO=1 trial autobahn.wamp.test.test_wamp_cryptosign
	USE_TWISTED=1 trial autobahn.wamp.test.test_wamp_cryptosign

test_wamp_scram:
	USE_ASYNCIO=1 trial autobahn.wamp.test.test_wamp_scram
	USE_TWISTED=1 trial autobahn.wamp.test.test_wamp_scram

test_xbr_argon2:
	USE_ASYNCIO=1 trial autobahn.xbr.test.test_xbr_argon2
	USE_TWISTED=1 trial autobahn.xbr.test.test_xbr_argon2

test_xbr_config:
	USE_TWISTED=1 trial autobahn.xbr.test.test_xbr_config

test_twisted_coverage:
	-rm .coverage
	USE_TWISTED=1 coverage run --omit=*/test/* --source=autobahn `which trial` autobahn
#	coverage -a -d annotated_coverage
	coverage html
	coverage report --show-missing

test_coverage:
	-rm .coverage
	tox -e py27-twtrunk,py27-asyncio,py36-asyncio
	coverage combine
	coverage html
	coverage report --show-missing

# test under asyncio
test_asyncio:
	USE_ASYNCIO=1 python -m pytest -rsx autobahn
	#WAMP_ROUTER_URL="ws://127.0.0.1:8080/ws" USE_ASYNCIO=1 python -m pytest -rsx

test_cs1:
	USE_ASYNCIO=1 python -m pytest -s -v autobahn/wamp/test/test_cryptosign.py

test1:
	USE_TWISTED=1 trial autobahn.wamp.test.test_auth
#	USE_TWISTED=1 python -m pytest -s -v autobahn/wamp/test/test_auth.py
#	USE_TWISTED=1 python -m pytest -s -v autobahn/wamp/test/test_router.py
#	USE_ASYNCIO=1 python -m pytest -s -v autobahn/wamp/test/test_router.py

test2:
#	USE_TWISTED=1 python -m pytest -s -v autobahn/wamp/test/test_router.py
	USE_ASYNCIO=1 python -m pytest -s -v autobahn/wamp/test/test_router.py
#	trial autobahn
#	trial autobahn.websocket.test
#	trial autobahn.wamp.test
#	trial autobahn.wamp.test.test_component
#	trial autobahn.wamp.test.test_message
#	trial autobahn.wamp.test.test_protocol
#	trial autobahn.wamp.test.test_protocol_peer
#	trial autobahn.wamp.test.test_serializer
#	trial autobahn.wamp.test.test_uri_pattern

pyflakes:
	pyflakes .

# run PEP8 check and print statistics
pep8:
	pep8 --statistics --ignore=E501 -qq autobahn

# run PEP8 check and show source for offending code
pep8show:
	pep8 --show-source --ignore=E501 autobahn

# run autopep8 to automatically transform offending code
autopep8:
	autopep8 -ri --aggressive autobahn

# This will run pep8, pyflakes and can skip lines that end with # noqa
flake8:
	flake8 --ignore=E402,E501,E722,E741,N801,N802,N803,N805,N806,N815 \
	    --exclude "autobahn/wamp/message_fbs.py,autobahn/wamp/gen/*"\
	    autobahn

# run PyLint
pylint:
	pylint -d line-too-long,invalid-name autobahn

# on Unix, check for files with Windows line endings
find_windows_files:
	find . -name "*" -exec file {} \; | grep "CRLF"

# on Windows (Git Bash), check for files with Unix lines endings
find_unix_files:
	find . -name "*" -exec dos2unix -tv {} \; 2>&1 | grep "Unix"

# sudo apt install gource ffmpeg
gource:
	gource \
	--path . \
	--seconds-per-day 0.15 \
	--title "autobahn-python" \
	-1280x720 \
	--file-idle-time 0 \
	--auto-skip-seconds 0.75 \
	--multi-sampling \
	--stop-at-end \
	--highlight-users \
	--hide filenames,mouse,progress \
	--max-files 0 \
	--background-colour 000000 \
	--disable-bloom \
	--font-size 24 \
	--output-ppm-stream - \
	--output-framerate 30 \
	-o - \
	| ffmpeg \
	-y \
	-r 60 \
	-f image2pipe \
	-vcodec ppm \
	-i - \
	-vcodec libx264 \
	-preset ultrafast \
	-pix_fmt yuv420p \
	-crf 1 \
	-threads 0 \
	-bf 0 \
	autobahn-python.mp4

#
# generate (a special set of) WAMP message classes from FlatBuffers schema
#

# input .fbs files for schema
FBSFILES=./autobahn/wamp/flatbuffers/*.fbs

# flatc compiler to use
FLATC=flatc

clean_fbs:
	-rm -rf ./autobahn/wamp/gen/

build_fbs:
	# generate schema type library (*.bfbs files)
	$(FLATC) -o ./autobahn/wamp/gen/schema/ --binary --schema --bfbs-comments --bfbs-builtins $(FBSFILES)
	@find ./autobahn/wamp/gen/schema/ -name "*.bfbs" | wc -l

	# generate schema Python bindings (*.py files)
	$(FLATC) -o ./autobahn/wamp/gen/ --python $(FBSFILES)
	@find ./autobahn/wamp/gen/ -name "*.py" | wc -l

	# generate schema C++ bindings (*.cpp/hpp files)
	# $(FLATC) -o /tmp/gen/ --cpp $(FBSFILES)
	# @find /tmp/gen/

=== docker/Makefile ===
WHEELS=https://crossbarbuilder.s3.eu-central-1.amazonaws.com/wheels

default:
	@echo ""
	@echo "Targets:"
	@echo ""
	@echo "  params                 Print build parameters"
	@echo "  build                  Build images"
	@echo "  test                   Test images"
	@echo "  publish                Publish images"
	@echo ""

params:
	@echo ""
	@echo "Build environment configured:"
	@echo ""
	@echo "${AUTOBAHN_BUILD_DATE}"
	@echo "${AUTOBAHN_BUILD_ID}"
	@echo "${AUTOBAHN_VCS_REF}"
	@echo "${AUTOBAHN_VERSION}"
	@echo ""


install_qemu:
	sudo apt-get update
	sudo apt-get install -y qemu qemu-kvm qemu-system qemu-system-x86 qemu-system-arm
	sudo apt-get install -y --no-install-recommends qemu-user-static binfmt-support
	sudo update-binfmts --enable qemu-arm
	sudo update-binfmts --enable qemu-aarch64
	sudo update-binfmts --display qemu-arm
	sudo update-binfmts --display qemu-aarch64

copy_qemu:
	mkdir -p ./.qemu
	cp /usr/bin/qemu-aarch64-static ./.qemu
	cp /usr/bin/qemu-arm-static ./.qemu


clean_wheels:
	rm -rf ./.wheels
	mkdir -p ./.wheels/

download_wheels:
	mkdir -p ./.wheels/
	rm -f ./.wheels/*.whl
	curl -o ./.wheels/txaio-latest-py2.py3-none-any.whl 	$(WHEELS)/txaio-latest-py2.py3-none-any.whl
	curl -o ./.wheels/zlmdb-latest-py2.py3-none-any.whl 	$(WHEELS)/zlmdb-latest-py2.py3-none-any.whl
	curl -o ./.wheels/xbr-latest-py2.py3-none-any.whl 		$(WHEELS)/xbr-latest-py2.py3-none-any.whl
	curl -o ./.wheels/autobahn-latest-py2.py3-none-any.whl 	$(WHEELS)/autobahn-latest-py2.py3-none-any.whl
	ls -la ./.wheels

build_this_wheel:
	mkdir -p ./.wheels/
	rm -f ./.wheels/autobahn*.whl
	pip3 wheel --no-deps --wheel-dir=./.wheels ..
	mv .wheels/autobahn*.whl .wheels/autobahn-latest-py2.py3-none-any.whl
	ls -la ./.wheels


# WARNING: this will stop and remove all containers on the local host!
docker_stop_rm:
	-docker stop $(docker ps -a -q)
	-docker rm $(docker ps -a -q -f)


build: build_cpy build_pypy

test: test_cpy test_pypy

publish: publish_cpy publish_pypy


build_amd64: build_cpy_amd64 build_pypy_amd64

test_amd64: test_cpy_amd64 test_pypy_amd64

publish_amd64: publish_cpy_amd64 publish_pypy_amd64


build_arm64v8: build_cpy_arm64v8 build_pypy_arm64v8

test_arm64v8: test_cpy_arm64v8 test_pypy_arm64v8

publish_arm64v8: publish_cpy_arm64v8 publish_pypy_arm64v8


build_cpy: build_cpy_amd64 build_cpy_arm64v8

test_cpy: test_cpy_amd64 test_cpy_arm64v8

publish_cpy: publish_cpy_amd64 publish_cpy_arm64v8


build_pypy: build_pypy_amd64 build_pypy_arm64v8

test_pypy: test_pypy_amd64 test_pypy_arm64v8

publish_pypy: publish_pypy_amd64 publish_pypy_arm64v8


build_cpy_amd64:
	docker build \
		--build-arg AUTOBAHN_ARCH=amd64 \
		--build-arg AUTOBAHN_BUILD_ID=${AUTOBAHN_BUILD_ID} \
		--build-arg AUTOBAHN_BUILD_DATE=${AUTOBAHN_BUILD_DATE} \
		--build-arg AUTOBAHN_VCS_REF=${AUTOBAHN_VCS_REF} \
		--build-arg AUTOBAHN_VERSION=${AUTOBAHN_VERSION} \
		-t crossbario/autobahn-python:cpy-amd64 \
		-t crossbario/autobahn-python:cpy-amd64-${AUTOBAHN_VERSION} \
		-t crossbario/autobahn-python:cpy-amd64-${AUTOBAHN_VERSION}-${AUTOBAHN_BUILD_ID} \
		-f Dockerfile.cpy-slim .
	docker images crossbario/autobahn-python:cpy-amd64

test_cpy_amd64:
	docker run --rm crossbario/autobahn-python:cpy-amd64

publish_cpy_amd64:
	docker push crossbario/autobahn-python:cpy-amd64
	docker push crossbario/autobahn-python:cpy-amd64-${AUTOBAHN_VERSION}
	docker push crossbario/autobahn-python:cpy-amd64-${AUTOBAHN_VERSION}-${AUTOBAHN_BUILD_ID}


build_cpy_arm64v8:
	docker build \
		--build-arg AUTOBAHN_ARCH=arm64v8 \
		--build-arg AUTOBAHN_BUILD_ID=${AUTOBAHN_BUILD_ID} \
		--build-arg AUTOBAHN_BUILD_DATE=${AUTOBAHN_BUILD_DATE} \
		--build-arg AUTOBAHN_VCS_REF=${AUTOBAHN_VCS_REF} \
		--build-arg AUTOBAHN_VERSION=${AUTOBAHN_VERSION} \
		-t crossbario/autobahn-python:cpy-arm64v8 \
		-t crossbario/autobahn-python:cpy-arm64v8-${AUTOBAHN_VERSION} \
		-t crossbario/autobahn-python:cpy-arm64v8-${AUTOBAHN_VERSION}-${AUTOBAHN_BUILD_ID} \
		-f ./Dockerfile.cpy-slim .
	docker images crossbario/autobahn-python:cpy-arm64v8

test_cpy_arm64v8:
	docker run --rm crossbario/autobahn-python:cpy-arm64v8

publish_cpy_arm64v8:
	docker push crossbario/autobahn-python:cpy-arm64v8
	docker push crossbario/autobahn-python:cpy-arm64v8-${AUTOBAHN_VERSION}
	docker push crossbario/autobahn-python:cpy-arm64v8-${AUTOBAHN_VERSION}-${AUTOBAHN_BUILD_ID}


build_pypy_amd64:
	docker build \
		--build-arg AUTOBAHN_ARCH=amd64 \
		--build-arg AUTOBAHN_BUILD_ID=${AUTOBAHN_BUILD_ID} \
		--build-arg AUTOBAHN_BUILD_DATE=${AUTOBAHN_BUILD_DATE} \
		--build-arg AUTOBAHN_VCS_REF=${AUTOBAHN_VCS_REF} \
		--build-arg AUTOBAHN_VERSION=${AUTOBAHN_VERSION} \
		-t crossbario/autobahn-python:pypy-amd64 \
		-t crossbario/autobahn-python:pypy-amd64-${AUTOBAHN_VERSION} \
		-t crossbario/autobahn-python:pypy-amd64-${AUTOBAHN_VERSION}-${AUTOBAHN_BUILD_ID} \
		-f Dockerfile.pypy-slim .
	docker images crossbario/autobahn-python:pypy-amd64

test_pypy_amd64:
	docker run --rm crossbario/autobahn-python:pypy-amd64

publish_pypy_amd64:
	docker push crossbario/autobahn-python:pypy-amd64
	docker push crossbario/autobahn-python:pypy-amd64-${AUTOBAHN_VERSION}
	docker push crossbario/autobahn-python:pypy-amd64-${AUTOBAHN_VERSION}-${AUTOBAHN_BUILD_ID}


build_pypy_arm64v8:
	docker build \
		--build-arg AUTOBAHN_ARCH=arm64v8 \
		--build-arg AUTOBAHN_BUILD_ID=${AUTOBAHN_BUILD_ID} \
		--build-arg AUTOBAHN_BUILD_DATE=${AUTOBAHN_BUILD_DATE} \
		--build-arg AUTOBAHN_VCS_REF=${AUTOBAHN_VCS_REF} \
		--build-arg AUTOBAHN_VERSION=${AUTOBAHN_VERSION} \
		-t crossbario/autobahn-python:pypy-arm64v8 \
		-t crossbario/autobahn-python:pypy-arm64v8-${AUTOBAHN_VERSION} \
		-t crossbario/autobahn-python:pypy-arm64v8-${AUTOBAHN_VERSION}-${AUTOBAHN_BUILD_ID} \
		-f ./Dockerfile.pypy-slim .
	docker images crossbario/autobahn-python:pypy-arm64v8

test_pypy_arm64v8:
	docker run --rm crossbario/autobahn-python:pypy-arm64v8

publish_pypy_arm64v8:
	docker push crossbario/autobahn-python:pypy-arm64v8
	docker push crossbario/autobahn-python:pypy-arm64v8-${AUTOBAHN_VERSION}
	docker push crossbario/autobahn-python:pypy-arm64v8-${AUTOBAHN_VERSION}-${AUTOBAHN_BUILD_ID}


# Docker multi-arch manifest
#
# https://docs.docker.com/engine/reference/commandline/manifest/
# https://docs.docker.com/docker-for-mac/multi-arch/
# https://www.docker.com/blog/multi-arch-build-and-images-the-simple-way/
# https://docs.docker.com/registry/spec/manifest-v2-2/
#
# Use the following options for different CPU archs:
#
#	--os linux --arch amd64
#	--os linux --arch 386
#	--os linux --arch arm64 --variant armv8
#	--os linux --arch arm
#
# Older Docker CLI needs: export DOCKER_CLI_EXPERIMENTAL=enabled
#
publish_manifest: publish_cpy_manifest publish_pypy_manifest

publish_cpy_manifest:
	docker manifest create --amend \
		crossbario/autobahn-python:cpy \
		crossbario/autobahn-python:cpy-amd64-${AUTOBAHN_VERSION}-${AUTOBAHN_BUILD_ID} \
		crossbario/autobahn-python:cpy-arm64v8-${AUTOBAHN_VERSION}-${AUTOBAHN_BUILD_ID} \

	docker manifest annotate \
		crossbario/autobahn-python:cpy \
		crossbario/autobahn-python:cpy-amd64-${AUTOBAHN_VERSION}-${AUTOBAHN_BUILD_ID} \
		--os linux --arch amd64

	docker manifest annotate \
		crossbario/autobahn-python:cpy \
		crossbario/autobahn-python:cpy-arm64v8-${AUTOBAHN_VERSION}-${AUTOBAHN_BUILD_ID} \
		--os linux --arch arm64 --variant armv8

	docker manifest inspect \
		crossbario/autobahn-python:cpy

	docker manifest push --purge \
		crossbario/autobahn-python:cpy

publish_pypy_manifest:
	docker manifest create --amend \
		crossbario/autobahn-python:pypy \
		crossbario/autobahn-python:pypy-amd64-${AUTOBAHN_VERSION}-${AUTOBAHN_BUILD_ID} \
		crossbario/autobahn-python:pypy-arm64v8-${AUTOBAHN_VERSION}-${AUTOBAHN_BUILD_ID} \

	docker manifest annotate \
		crossbario/autobahn-python:pypy \
		crossbario/autobahn-python:pypy-amd64-${AUTOBAHN_VERSION}-${AUTOBAHN_BUILD_ID} \
		--os linux --arch amd64

	docker manifest annotate \
		crossbario/autobahn-python:pypy \
		crossbario/autobahn-python:pypy-arm64v8-${AUTOBAHN_VERSION}-${AUTOBAHN_BUILD_ID} \
		--os linux --arch arm64 --variant armv8

	docker manifest inspect \
		crossbario/autobahn-python:pypy

	docker manifest push --purge \
		crossbario/autobahn-python:pypy

=== wstest/Makefile ===
.PHONY: downloads

CURDIR := $(CURDIR)
REPORTDATE := `date -u +"%Y-%m-%d"`

AUTOBAHN_TESTSUITE_DOCKER := crossbario/autobahn-testsuite:0.8.2@sha256:5d4ba3aa7d6ab2fdbf6606f3f4ecbe4b66f205ce1cbc176d6cdf650157e52242

default:
	@echo 'targets: clean, downloads, build_wstest'


clean:
	-rm -rf ./reports
	-rm -rf ./venv*
	-rm -rf ./wstest

dist_clean: clean
	-rm -rf ./downloads

clean_reports:
	-rm -rf ./reports

# https://s3.eu-central-1.amazonaws.com/crossbario.com/reports/autobahn-testsuite-2021-03-16/clients/index.html
# https://crossbario.com/reports/autobahn-testsuite-2021-03-16/clients/index.html
upload_reports:
	./wstest/bin/aws s3 sync \
		--delete --acl public-read --region=eu-central-1 \
		reports \
		s3://crossbario.com/reports/autobahn-testsuite-$(REPORTDATE)


downloads:
	mkdir -p downloads
	wget -P downloads https://bootstrap.pypa.io/get-pip.py
	wget -P downloads https://downloads.python.org/pypy/pypy2.7-v7.3.3-linux64.tar.bz2
	wget -P downloads https://downloads.python.org/pypy/pypy3.7-v7.3.3-linux64.tar.bz2
	wget -P downloads https://www.python.org/ftp/python/2.7.18/Python-2.7.18.tar.xz
	wget -P downloads https://www.python.org/ftp/python/3.9.2/Python-3.9.2.tar.xz


# needs CPython 2 or PyPy 2, and https://pypi.org/project/autobahntestsuite/0.8.2/
build_wstest:
	mkdir -p ./wstest
	tar xvf ./downloads/pypy2.7-v7.3.3-linux64.tar.bz2 --strip-components=1 -C ./wstest
	./wstest/bin/pypy ./downloads/get-pip.py
	# ./wstest/bin/pip install -e ../../autobahn-testsuite/autobahntestsuite
	./wstest/bin/pip install "autobahntestsuite>=0.8.2"
	./wstest/bin/pip install awscli


build_pypy3:
	rm -rf ./pypy3
	mkdir -p ./pypy3
	tar xvf ./downloads/pypy3.7-v7.3.3-linux64.tar.bz2 --strip-components=1 -C ./pypy3
	cd ./pypy3/bin && ln -s pypy3 python && cd ../..
	./pypy3/bin/python ./downloads/get-pip.py
	./pypy3/bin/pip install virtualenv
	./pypy3/bin/python -V

build_cpy3:
	rm -rf ./cpy3_build
	mkdir -p ./cpy3_build
	tar xvf ./downloads/Python-3.9.2.tar.xz --strip-components=1 -C ./cpy3_build
	cd ./cpy3_build && ./configure --prefix=${CURDIR}/cpy3 && make && make install
	rm -rf ./cpy3_build
	./cpy3/bin/pip install virtualenv
	./cpy3/bin/python -V

build: build_wstest \
	   build_pypy3 \
	   build_cpy3


setup_pypy3_tx:
	./pypy3/bin/virtualenv ./venv_pypy3_tx
	cd .. && ./wstest/venv_pypy3_tx/bin/pip install -e .[twisted,compress]

setup_pypy3_aio:
	./pypy3/bin/virtualenv ./venv_pypy3_aio
	cd .. && ./wstest/venv_pypy3_aio/bin/pip install -e .[asyncio,compress]

setup_cpy3_tx:
	./cpy3/bin/virtualenv ./venv_cpy3_tx
	cd .. && ./wstest/venv_cpy3_tx/bin/pip install -e .[accelerate,twisted,compress]

setup_cpy3_aio:
	./cpy3/bin/virtualenv ./venv_cpy3_aio
	cd .. && ./wstest/venv_cpy3_aio/bin/pip install -e .[accelerate,asyncio,compress]

setup: setup_pypy3_tx setup_pypy3_aio setup_cpy3_tx setup_cpy3_aio


versions:
	@echo ""
	@echo "wstest (uses PyPy 2):"
	@echo ""
	./wstest/bin/pypy -V

	@echo ""
	@echo "CPython 3:"
	@echo ""
	./cpy3/bin/python -V
	@echo "Autobahn - CPython 3 / Twisted:"
	@./venv_cpy3_tx/bin/python -c "import autobahn; print('autobahn-{}'.format(autobahn.__version__))"
	@echo "Autobahn - CPython 3 / asyncio:"
	@./venv_cpy3_aio/bin/python -c "import autobahn; print('autobahn-{}'.format(autobahn.__version__))"

	@echo ""
	@echo "PyPy 3:"
	@echo ""
	./pypy3/bin/python -V
	@echo "Autobahn - PyPy 3 / Twisted:"
	@./venv_pypy3_tx/bin/python -c "import autobahn; print('autobahn-{}'.format(autobahn.__version__))"
	@echo "Autobahn - PyPy 3 / asyncio:"
	@./venv_pypy3_aio/bin/python -c "import autobahn; print('autobahn-{}'.format(autobahn.__version__))"


wstest_server_full:
	./wstest/bin/wstest -m fuzzingserver --spec=fuzzingserver-full.json

wstest_server_quick:
	./wstest/bin/wstest -m fuzzingserver --spec=fuzzingserver-quick.json


wstest_server_docker_pull:
	docker pull $(AUTOBAHN_TESTSUITE_DOCKER)

wstest_server_docker_stop:
	docker rm --force fuzzingserver

wstest_server_docker_full:
	docker run -it --rm \
		-v ${PWD}/fuzzingserver-full.json:/config/fuzzingserver.json:ro \
		-v ${PWD}/reports:/reports \
		-p 9001:9001 \
		--name autobahn \
		$(AUTOBAHN_TESTSUITE_DOCKER)

wstest_server_docker_quick:
	docker run -d --rm --name fuzzingserver \
		-u `id -u`:`id -g` \
		-v ${PWD}/fuzzingserver-quick.json:/config/fuzzingserver.json:ro \
		-v ${PWD}/reports:/reports \
		-p 9001:9001 \
		$(AUTOBAHN_TESTSUITE_DOCKER)


test_pypy3_tx_client:
	./venv_pypy3_tx/bin/python testee_client_tx.py

test_pypy3_aio_client:
	./venv_pypy3_tx/bin/python testee_client_aio.py

test_cpy3_tx_client:
	./venv_cpy3_tx/bin/python testee_client_tx.py

test_cpy3_aio_client:
	./venv_cpy3_tx/bin/python testee_client_aio.py

test_tx_clients: \
	test_pypy3_tx_client \
	test_cpy3_tx_client

test_aio_clients: \
	test_pypy3_aio_client \
	test_cpy3_aio_client

test_clients: \
	test_tx_clients \
	test_aio_clients


start_cpy3_tx_server:
	./venv_cpy3_tx/bin/python testee_server_tx.py --url ws://127.0.0.1:9011 &

start_pypy3_tx_server:
	./venv_pypy3_tx/bin/python testee_server_tx.py --url ws://127.0.0.1:9013 &

start_cpy3_aio_server:
	./venv_cpy3_aio/bin/python testee_server_aio.py --url ws://127.0.0.1:9015 &

start_pypy3_aio_server:
	./venv_pypy3_aio/bin/python testee_server_aio.py --url ws://127.0.0.1:9017 &

start_tx_servers: \
	start_cpy3_tx_server \
	start_pypy3_tx_server

start_aio_servers: \
	start_cpy3_aio_server \
	start_pypy3_aio_server

start_servers: \
	start_tx_servers \
	start_aio_servers

stop_servers:
	-pkill -f "testee_server*"


# test individual server flavor - note that this will only
# produce a single report each, and it cannot be combined into
# a single report! here is the comment from wstest.py

# allow overriding servers from command line option, providing 1 server
# this is semi-useful, as you cannot accumulate a combined report for
# multiple servers by running wstest over and over again. the generated
# report is only for the last invocation - it would require a massive
# code restructering / rewriting to change that. no time for that unfort.

test_cpy3_tx_server:
	./wstest/bin/wstest -m fuzzingclient --spec=fuzzingclient-quick.json -w ws://127.0.0.1:9011

test_pypy3_tx_server:
	./wstest/bin/wstest -m fuzzingclient --spec=fuzzingclient-quick.json -w ws://127.0.0.1:9013

test_cpy3_aio_server:
	./wstest/bin/wstest -m fuzzingclient --spec=fuzzingclient-quick.json -w ws://127.0.0.1:9015

test_pypy3_aio_server:
	./wstest/bin/wstest -m fuzzingclient --spec=fuzzingclient-quick.json -w ws://127.0.0.1:9017

test_tx_servers: \
	test_cpy3_tx_server \
	test_pypy3_tx_server

test_aio_servers: \
	test_cpy3_aio_server \
	test_pypy3_aio_server

# THIS DOES NOT WORK TO PRODUCE THE FINAL COMBINED REPORT FOR ALL SERVERS!
# see above.
#test_server: \
#	test_tx_servers \
#	test_aio_servers


test_servers:
	./wstest/bin/wstest -m fuzzingclient --spec=fuzzingclient-quick.json

=== debian/rules ===
#!/usr/bin/make -f

UPSTREAM_GIT := https://github.com/crossbario/autobahn-python
include /usr/share/openstack-pkg-tools/pkgos.make

# Needed for tests:
export PYUBJSON_NO_EXTENSION=1
export AUTOBAHN_USE_NVX=0
export AUTOBAHN_USE_UJSON=1
export AUTOBAHN_USE_CBOR2=0
export USE_TWISTED=0
export USE_ASYNCIO = 1

%:
	dh $@ --buildsystem=python_distutils --with python3

override_dh_auto_clean:
	rm -rf build .stestr
	find . -iname '*.pyc' -delete
	for i in $$(find . -type d -iname __pycache__) ; do rm -rf $$i ; done

override_dh_auto_build:
	echo "Do nothing..."

override_dh_auto_install:
	pkgos-dh_auto_install --no-py2 --in-tmp

override_dh_auto_test:
ifeq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
	set -e ; set -x ; for i in $(PYTHON3S) ; do \
		rm -rf build ; \
		PYTHONPATH=. python$$i -m pytest -Wignore -v --ignore=./autobahn/twisted --ignore=./autobahn/wamp --ignore=./autobahn/websocket --ignore=./autobahn/xbr autobahn; \
	done
endif

override_dh_clean:
	dh_clean -O--buildsystem=python_distutils
	rm -rf build twisted/plugins/dropin.cache

## python-autobahn 22.1.1+dfsg1

=== Makefile ===
--- 
+++ 
@@ -69,7 +69,7 @@
 
 # publish to PyPI
 publish: clean
-	AUTOBAHN_USE_NVX=0 python setup.py sdist --universal
+	AUTOBAHN_USE_NVX=0 python setup.py sdist
 	twine upload dist/*
 
 clean_docs:
@@ -101,7 +101,7 @@
 build_this_wheel:
 	mkdir -p ./.wheels/
 	rm -f ./.wheels/autobahn*.whl
-	pip3 wheel --no-deps --wheel-dir=./.wheels ..
+	pip3 wheel --no-deps --wheel-dir=./.wheels .
 	mv .wheels/autobahn*.whl .wheels/autobahn-latest-py2.py3-none-any.whl
 	ls -la ./.wheels

=== debian/changelog ===
python-autobahn (22.1.1+dfsg1-3) unstable; urgency=medium

  * Add dh_python3 --shebang=/usr/bin/python3 (Closes: #1017048).

 -- Thomas Goirand <zigo@debian.org>  Mon, 15 Aug 2022 15:44:51 +0200

python-autobahn (22.1.1+dfsg1-2) unstable; urgency=medium

  * Uploading to unstable.

 -- Thomas Goirand <zigo@debian.org>  Wed, 23 Mar 2022 15:47:31 +0100

python-autobahn (22.1.1+dfsg1-1) experimental; urgency=medium

  * New upstream release.

 -- Thomas Goirand <zigo@debian.org>  Wed, 16 Feb 2022 10:58:15 +0100

=== debian/rules ===
--- 
+++ 
@@ -36,3 +36,6 @@
 override_dh_clean:
 	dh_clean -O--buildsystem=python_distutils
 	rm -rf build twisted/plugins/dropin.cache
+
+override_dh_python3:
+	dh_python3 --shebang=/usr/bin/python3

## python-autobahn 22.7.1%2Bdfsg1

=== debian/rules ===
--- 
+++ 
@@ -8,14 +8,13 @@
 export AUTOBAHN_USE_NVX=0
 export AUTOBAHN_USE_UJSON=1
 export AUTOBAHN_USE_CBOR2=0
-export USE_TWISTED=0
-export USE_ASYNCIO = 1
+export USE_ASYNCIO=1
 
 %:
 	dh $@ --buildsystem=python_distutils --with python3
 
 override_dh_auto_clean:
-	rm -rf build .stestr
+	rm -rf build .stestr .pytest_cache *.egg-info
 	find . -iname '*.pyc' -delete
 	for i in $$(find . -type d -iname __pycache__) ; do rm -rf $$i ; done
